commit ccfd7246e2035a5390cb9f2ce55daa031c59d8b2
Author: Dominic Cleal <dcleal@redhat.com>
Date:   Tue Sep 8 14:53:01 2015 +0100

    Remove unused fastercsv, rb-readline deps

diff --git a/comps/comps-foreman-fedora19.xml b/comps/comps-foreman-fedora19.xml
index 65eb7d466..eca6c141d 100644
--- a/comps/comps-foreman-fedora19.xml
+++ b/comps/comps-foreman-fedora19.xml
@@ -44,7 +44,6 @@
       <packagereq type="default">rubygem-extlib</packagereq>
       <packagereq type="default">rubygem-faraday</packagereq>
       <packagereq type="default">rubygem-fast_gettext</packagereq>
-      <packagereq type="default">rubygem-fastercsv</packagereq>
       <packagereq type="default">rubygem-flot-rails</packagereq>
       <packagereq type="default">rubygem-fog</packagereq>
       <packagereq type="default">rubygem-fog-aws</packagereq>
@@ -84,7 +83,6 @@
       <packagereq type="default">rubygem-rabl</packagereq>
       <packagereq type="default">rubygem-rack-jsonp</packagereq>
       <packagereq type="default">rubygem-rails-i18n</packagereq>
-      <packagereq type="default">rubygem-rb-readline</packagereq>
       <packagereq type="default">rubygem-rbovirt</packagereq>
       <packagereq type="default">rubygem-rbvmomi</packagereq>
       <packagereq type="default">rubygem-retriable</packagereq>
@@ -159,7 +157,6 @@
       <packagereq type="default">rubygem-rack-jsonp-doc</packagereq>
       <packagereq type="default">rubygem-rails-i18n-doc</packagereq>
       <packagereq type="default">rubygem-rbovirt-doc</packagereq>
-      <packagereq type="default">rubygem-rb-readline-doc</packagereq>
       <packagereq type="default">rubygem-rbvmomi-doc</packagereq>
       <packagereq type="default">rubygem-retriable-doc</packagereq>
       <packagereq type="default">rubygem-ruby2ruby-doc</packagereq>
diff --git a/comps/comps-foreman-rhel6.xml b/comps/comps-foreman-rhel6.xml
index bf73a06a0..548e4c188 100644
--- a/comps/comps-foreman-rhel6.xml
+++ b/comps/comps-foreman-rhel6.xml
@@ -59,7 +59,6 @@
       <packagereq type="default">tfm-rubygem-extlib</packagereq>
       <packagereq type="default">tfm-rubygem-facter</packagereq>
       <packagereq type="default">tfm-rubygem-faraday</packagereq>
-      <packagereq type="default">tfm-rubygem-fastercsv</packagereq>
       <packagereq type="default">tfm-rubygem-fast_gettext</packagereq>
       <packagereq type="default">tfm-rubygem-flot-rails</packagereq>
       <packagereq type="default">tfm-rubygem-fog</packagereq>
@@ -117,7 +116,6 @@
       <packagereq type="default">tfm-rubygem-rack-jsonp</packagereq>
       <packagereq type="default">tfm-rubygem-rails-i18n</packagereq>
       <packagereq type="default">tfm-rubygem-rbovirt</packagereq>
-      <packagereq type="default">tfm-rubygem-rb-readline</packagereq>
       <packagereq type="default">tfm-rubygem-rbvmomi</packagereq>
       <packagereq type="default">tfm-rubygem-rest-client</packagereq>
       <packagereq type="default">tfm-rubygem-retriable</packagereq>
@@ -281,7 +279,6 @@
       <packagereq type="default">tfm-rubygem-rack-jsonp-doc</packagereq>
       <packagereq type="default">tfm-rubygem-rails-i18n-doc</packagereq>
       <packagereq type="default">tfm-rubygem-rbovirt-doc</packagereq>
-      <packagereq type="default">tfm-rubygem-rb-readline-doc</packagereq>
       <packagereq type="default">tfm-rubygem-rbvmomi-doc</packagereq>
       <packagereq type="default">tfm-rubygem-retriable-doc</packagereq>
       <packagereq type="default">tfm-rubygem-rr-doc</packagereq>
diff --git a/comps/comps-foreman-rhel7.xml b/comps/comps-foreman-rhel7.xml
index 23a9664f5..35bc6b6b3 100644
--- a/comps/comps-foreman-rhel7.xml
+++ b/comps/comps-foreman-rhel7.xml
@@ -59,7 +59,6 @@
       <packagereq type="default">tfm-rubygem-extlib</packagereq>
       <packagereq type="default">tfm-rubygem-facter</packagereq>
       <packagereq type="default">tfm-rubygem-faraday</packagereq>
-      <packagereq type="default">tfm-rubygem-fastercsv</packagereq>
       <packagereq type="default">tfm-rubygem-fast_gettext</packagereq>
       <packagereq type="default">tfm-rubygem-flot-rails</packagereq>
       <packagereq type="default">tfm-rubygem-fog</packagereq>
@@ -117,7 +116,6 @@
       <packagereq type="default">tfm-rubygem-rack-jsonp</packagereq>
       <packagereq type="default">tfm-rubygem-rails-i18n</packagereq>
       <packagereq type="default">tfm-rubygem-rbovirt</packagereq>
-      <packagereq type="default">tfm-rubygem-rb-readline</packagereq>
       <packagereq type="default">tfm-rubygem-rbvmomi</packagereq>
       <packagereq type="default">tfm-rubygem-rest-client</packagereq>
       <packagereq type="default">tfm-rubygem-retriable</packagereq>
@@ -284,7 +282,6 @@
       <packagereq type="default">tfm-rubygem-rack-jsonp-doc</packagereq>
       <packagereq type="default">tfm-rubygem-rails-i18n-doc</packagereq>
       <packagereq type="default">tfm-rubygem-rbovirt-doc</packagereq>
-      <packagereq type="default">tfm-rubygem-rb-readline-doc</packagereq>
       <packagereq type="default">tfm-rubygem-rbvmomi-doc</packagereq>
       <packagereq type="default">tfm-rubygem-retriable-doc</packagereq>
       <packagereq type="default">tfm-rubygem-rr-doc</packagereq>
diff --git a/rel-eng/tito.props b/rel-eng/tito.props
index b4ecbef3d..0a2b32d21 100644
--- a/rel-eng/tito.props
+++ b/rel-eng/tito.props
@@ -133,7 +133,6 @@ whitelist = foreman
   rubygem-foremancli
   rubygem-foreman_api
   rubygem-fast_gettext
-  rubygem-fastercsv
   rubygem-friendly_id
   rubygem-gettext_i18n_rails
   rubygem-gettext_i18n_rails_js
@@ -164,7 +163,6 @@ whitelist = foreman
   rubygem-rabl
   rubygem-rack-jsonp
   rubygem-rails-i18n
-  rubygem-rb-readline
   rubygem-rbvmomi
   rubygem-rbovirt
   rubygem-retriable
diff --git a/rubygem-fastercsv/fastercsv-1.5.4.gem b/rubygem-fastercsv/fastercsv-1.5.4.gem
deleted file mode 120000
index 3896591b2..000000000
--- a/rubygem-fastercsv/fastercsv-1.5.4.gem
+++ /dev/null
@@ -1 +0,0 @@
-../.git/annex/objects/pg/PP/SHA256E-s125440--11d84c899762234dff4ff67cf9c3fb467542afb5f7a184ef465b5964b987b100.4.gem/SHA256E-s125440--11d84c899762234dff4ff67cf9c3fb467542afb5f7a184ef465b5964b987b100.4.gem
\ No newline at end of file
diff --git a/rubygem-fastercsv/rubygem-fastercsv.spec b/rubygem-fastercsv/rubygem-fastercsv.spec
deleted file mode 100644
index e42a58658..000000000
--- a/rubygem-fastercsv/rubygem-fastercsv.spec
+++ /dev/null
@@ -1,114 +0,0 @@
-%{?scl:%scl_package rubygem-%{gem_name}}
-%{!?scl:%global pkg_name %{name}}
-
-%global gem_name fastercsv
-
-Summary:	Faster, smaller and cleaner replacement to standard CSV library
-Name:		%{?scl_prefix}rubygem-%{gem_name}
-Version:	1.5.4
-Release:	8%{?dist}
-License:	GPLv2 or Ruby
-Group:		Development/Languages
-URL:		http://fastercsv.rubyforge.org/
-Source:		http://gems.rubyforge.org/gems/%{gem_name}-%{version}.gem
-
-%if "%{?scl_ruby}" == "ruby193" || (0%{?el6} && 0%{!?scl:1})
-Requires:	%{?scl_prefix_ruby}ruby(abi)
-%else
-Requires:	%{?scl_prefix_ruby}ruby(release)
-%endif
-Requires:	%{?scl_prefix_ruby}rubygems
-Provides:	%{?scl_prefix}rubygem(%{gem_name}) = %{version}
-%{?scl:Obsoletes: ruby193-rubygem-%{gem_name}}
-BuildRequires:	%{?scl_prefix_ruby}rubygems
-BuildRequires:  %{?scl_prefix_ruby}rubygems-devel
-BuildArch:	noarch
-
-%description
-FasterCSV is intended as a complete replacement to the CSV standard library.
-It is significantly faster and smaller while still being pure Ruby code. It
-also strives for a better interface.
-
-%prep
-
-%build
-
-%install
-rm -rf $RPM_BUILD_ROOT
-mkdir -p $RPM_BUILD_ROOT%{gem_dir}
-%{?scl:scl enable %{scl} "}
-gem install --local --install-dir $RPM_BUILD_ROOT%{gem_dir} --force --rdoc %{SOURCE0}
-%{?scl:"}
-
-# Find files with a shebang that do not have executable permissions
-for file in $(find $RPM_BUILD_ROOT%{gem_instdir} -type f ! -perm /a+x -name "*.rb"); do
-  if [ ! -z "`head -n 1 $file | grep \"^#!/\"`" ]; then
-    sed -e 's@/usr/local/bin/ruby@/usr/bin/%{?scl:%{scl_prefix}}ruby@g' -i $file
-    chmod -v 755 $file
-  fi
-done
-%{__rm} -Rf %{buildroot}/%{gem_instdir}/.yardoc
-
-%check
-#ruby -I $RPM_BUILD_ROOT%{gem_instdir}/lib:$RPM_BUILD_ROOT%{gem_instdir}/test $RPM_BUILD_ROOT%{gem_instdir}/test/ts_all.rb
-
-%files
-%doc %{gem_dir}/doc/%{gem_name}-%{version}
-%{gem_dir}/cache/%{gem_name}-%{version}.gem
-%{gem_dir}/specifications/%{gem_name}-%{version}.gemspec
-%dir %{gem_dir}/gems/%{gem_name}-%{version}/
-%doc %{gem_instdir}/AUTHORS
-%doc %{gem_instdir}/CHANGELOG
-%doc %{gem_instdir}/COPYING
-%doc %{gem_instdir}/INSTALL
-%doc %{gem_instdir}/LICENSE
-%doc %{gem_instdir}/README
-%doc %{gem_instdir}/TODO
-%{gem_instdir}/Rakefile
-%{gem_instdir}/examples/
-%{gem_instdir}/lib/
-%{gem_instdir}/setup.rb
-%{gem_instdir}/test/
-
-%changelog
-* Tue Aug 25 2015 Dominic Cleal <dcleal@redhat.com> 1.5.4-8
-- Use tfm-ruby for shebang line (dcleal@redhat.com)
-- Fix checks against scl name, optimise rhel/empty SCL conditional
-  (dcleal@redhat.com)
-- Converted to tfm SCL (dcleal@redhat.com)
-
-* Thu May 29 2014 Dominic Cleal <dcleal@redhat.com> 1.5.4-7
-- Modernise and update for EL7 (dcleal@redhat.com)
-
-* Tue Jan 07 2014 Dominic Cleal <dcleal@redhat.com> 1.5.4-6
-- Update spec for Fedora 19 with ruby(release) (dcleal@redhat.com)
-- remove empty tito.props and definition which are duplicate with default from
-  rel-eng/tito.props (msuchy@redhat.com)
-- with recent tito you do not need SCL meta package (msuchy@redhat.com)
-
-* Fri Mar 01 2013 Miroslav Suchý <msuchy@redhat.com> 1.5.4-4
-- new package built with tito
-
-* Mon Jul 16 2012 Miroslav Suchý <msuchy@redhat.com> 1.5.4-3
-- new package built with tito
-
-* Sat Jan 14 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.5.4-2
-- Rebuilt for https://fedoraproject.org/wiki/Fedora_17_Mass_Rebuild
-
-* Sat Oct 08 2011 Robert Scheck <robert@fedoraproject.org> 1.5.4-1
-- Upgrade to 1.5.4
-
-* Wed Feb 09 2011 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.5.1-2
-- Rebuilt for https://fedoraproject.org/wiki/Fedora_15_Mass_Rebuild
-
-* Sun Mar 28 2010 Robert Scheck <robert@fedoraproject.org> 1.5.1-1
-- Upgrade to 1.5.1
-
-* Sun Aug 09 2009 Robert Scheck <robert@fedoraproject.org> 1.5.0-2
-- Added missing requirement to ruby(abi) = version (#514928 #c1)
-- Switched from defines to globals, updated summary in spec file
-- Corrected license tag and removed duplicates in docs (#514928)
-
-* Fri Jul 31 2009 Robert Scheck <robert@fedoraproject.org> 1.5.0-1
-- Upgrade to 1.5.0
-- Initial spec file for Fedora and Red Hat Enterprise Linux
diff --git a/rubygem-rb-readline/rb-readline-0.5.1.gem b/rubygem-rb-readline/rb-readline-0.5.1.gem
deleted file mode 120000
index 8c4788156..000000000
--- a/rubygem-rb-readline/rb-readline-0.5.1.gem
+++ /dev/null
@@ -1 +0,0 @@
-../.git/annex/objects/6K/mg/SHA256-s96256--da4eb0aa71c4225e01f5b51e11a640b462fa325d85451428ce34190d04622aad/SHA256-s96256--da4eb0aa71c4225e01f5b51e11a640b462fa325d85451428ce34190d04622aad
\ No newline at end of file
diff --git a/rubygem-rb-readline/rubygem-rb-readline.spec b/rubygem-rb-readline/rubygem-rb-readline.spec
deleted file mode 100644
index aa730a22d..000000000
--- a/rubygem-rb-readline/rubygem-rb-readline.spec
+++ /dev/null
@@ -1,84 +0,0 @@
-%{?scl:%scl_package rubygem-%{gem_name}}
-%{!?scl:%global pkg_name %{name}}
-
-%global gem_name rb-readline
-
-Summary: Pure-Ruby Readline Implementation
-Name: %{?scl_prefix}rubygem-%{gem_name}
-Version: 0.5.1
-Release: 3%{?dist}
-Group: Development/Languages
-License: BSD
-URL: https://github.com/luislavena/rb-readline
-Source0: http://rubygems.org/downloads/%{gem_name}-%{version}.gem
-
-%if 0%{?scl:1} || (0%{?el6} && 0%{!?scl:1})
-Requires: %{?scl_prefix_ruby}ruby(abi)
-%else
-Requires: %{?scl_prefix_ruby}ruby(release)
-%endif
-BuildRequires: %{?scl_prefix_ruby}rubygems-devel
-%if 0%{?scl:1} || (0%{?el6} && 0%{!?scl:1})
-BuildRequires: %{?scl_prefix_ruby}ruby(abi)
-%else
-BuildRequires: %{?scl_prefix_ruby}ruby(release)
-%endif
-BuildRequires: %{?scl_prefix_ruby}ruby(rubygems)
-BuildRequires: %{?scl_prefix_ruby}ruby
-BuildArch: noarch
-Provides: %{?scl_prefix}rubygem(%{gem_name}) = %{version}
-%{?scl:Obsoletes: ruby193-rubygem-%{gem_name}}
-
-%description
-The readline library provides a pure Ruby implementation of the GNU readline C library,
-as well as the Readline extension that ships as part of the standard library.
-
-%package doc
-Summary: Documentation for %{pkg_name}
-Group: Documentation
-Requires: %{?scl_prefix}%{pkg_name} = %{version}-%{release}
-%{?scl:Obsoletes: ruby193-rubygem-%{gem_name}-doc}
-BuildArch: noarch
-
-%description doc
-Documentation for %{pkg_name}
-
-%prep
-%setup -n %{pkg_name}-%{version} -q -c -T
-mkdir -p .%{gem_dir}
-%{?scl:scl enable %{scl} - << \EOF}
-gem install --local --install-dir .%{gem_dir} \
-            --force %{SOURCE0}
-%{?scl:EOF}
-
-%install
-mkdir -p %{buildroot}%{gem_dir}
-cp -pa .%{gem_dir}/* %{buildroot}%{gem_dir}
-
-%files
-%dir %{gem_instdir}
-%{gem_instdir}/lib
-%{gem_instdir}/LICENSE
-%{gem_spec}
-%exclude %{gem_cache}
-%exclude %{gem_instdir}/Rakefile
-%exclude %{gem_instdir}/bench/_rl_adjust_point.rb
-%exclude %{gem_instdir}/setup.rb
-%exclude %{gem_instdir}/rb-readline.gemspec
-
-%files doc
-%doc %{gem_docdir}
-%doc %{gem_instdir}/test
-%doc %{gem_instdir}/examples
-%doc %{gem_instdir}/README.rdoc
-%doc %{gem_instdir}/CHANGES
-
-%changelog
-* Tue Aug 25 2015 Dominic Cleal <dcleal@redhat.com> 0.5.1-3
-- Converted to tfm SCL (dcleal@redhat.com)
-
-* Tue Jul 28 2015 Dominic Cleal <dcleal@redhat.com> 0.5.1-2
-- Convert rb-readline to SCL (dcleal@redhat.com)
-
-* Fri Aug 29 2014 Tomáš Strachota <tstrachota@redhat.com> 0.5.1-1
-- Added rb-readline 0.5.1 (tstrachota@redhat.com)