commit b8400d8759174f48567bee4d4e02bc21b5295351
Author: Dirk Goetz <dirk.goetz@netways.de>
Date:   Tue Jun 5 15:21:12 2018 +0200

    Add rubygem-foreman_rescue package

diff --git a/comps/comps-foreman-plugins-rhel7.xml b/comps/comps-foreman-plugins-rhel7.xml
index 7ecb9e38d..eebafac7b 100644
--- a/comps/comps-foreman-plugins-rhel7.xml
+++ b/comps/comps-foreman-plugins-rhel7.xml
@@ -90,6 +90,7 @@
       <packagereq type="default">tfm-rubygem-foreman_openscap</packagereq>
       <packagereq type="default">tfm-rubygem-foreman_remote_execution</packagereq>
       <packagereq type="default">tfm-rubygem-foreman_remote_execution_core</packagereq>
+      <packagereq type="default">tfm-rubygem-foreman_rescue</packagereq>
       <packagereq type="default">tfm-rubygem-foreman_salt</packagereq>
       <packagereq type="default">tfm-rubygem-foreman_setup</packagereq>
       <packagereq type="default">tfm-rubygem-foreman_snapshot_management</packagereq>
@@ -209,6 +210,7 @@
       <packagereq type="default">tfm-rubygem-foreman_openscap-doc</packagereq>
       <packagereq type="default">tfm-rubygem-foreman_remote_execution_core-doc</packagereq>
       <packagereq type="default">tfm-rubygem-foreman_remote_execution-doc</packagereq>
+      <packagereq type="default">tfm-rubygem-foreman_rescue-doc</packagereq>
       <packagereq type="default">tfm-rubygem-foreman_salt-doc</packagereq>
       <packagereq type="default">tfm-rubygem-foreman_setup-doc</packagereq>
       <packagereq type="default">tfm-rubygem-foreman_snapshot_management-doc</packagereq>
diff --git a/package_manifest.yaml b/package_manifest.yaml
index 590a03034..a688e36d7 100644
--- a/package_manifest.yaml
+++ b/package_manifest.yaml
@@ -388,6 +388,7 @@ plugins_packages:
     rubygem-foreman_openscap: {}
     rubygem-foreman_remote_execution: {}
     rubygem-foreman_remote_execution_core: {}
+    rubygem-foreman_rescue: {}
     rubygem-foreman_salt: {}
     rubygem-foreman_scap_client: {}
     rubygem-foreman_setup: {}
diff --git a/packages/plugins/rubygem-foreman_rescue/foreman_rescue-1.0.0.gem b/packages/plugins/rubygem-foreman_rescue/foreman_rescue-1.0.0.gem
new file mode 120000
index 000000000..cdb038aeb
--- /dev/null
+++ b/packages/plugins/rubygem-foreman_rescue/foreman_rescue-1.0.0.gem
@@ -0,0 +1 @@
+../../../.git/annex/objects/jM/wj/SHA256E-s23552--729dc7566dcd880c44bb575169e11c19daccb2853d91ac6b51d56cba60a2fbf4.0.gem/SHA256E-s23552--729dc7566dcd880c44bb575169e11c19daccb2853d91ac6b51d56cba60a2fbf4.0.gem
\ No newline at end of file
diff --git a/packages/plugins/rubygem-foreman_rescue/rubygem-foreman_rescue.spec b/packages/plugins/rubygem-foreman_rescue/rubygem-foreman_rescue.spec
new file mode 100644
index 000000000..cd18abdd0
--- /dev/null
+++ b/packages/plugins/rubygem-foreman_rescue/rubygem-foreman_rescue.spec
@@ -0,0 +1,100 @@
+%{?scl:%scl_package rubygem-%{gem_name}}
+%{!?scl:%global pkg_name %{name}}
+
+%global gem_name foreman_rescue
+%global plugin_name rescue
+%global foreman_min_version 1.17
+
+Name: %{?scl_prefix}rubygem-%{gem_name}
+Version: 1.0.0
+Release: 1%{?foremandist}%{?dist}
+Summary: Provides the ability to boot a host into a rescue system
+Group: Applications/Systems
+License: GPL-3.0
+URL: https://github.com/dm-drogeriemarkt/foreman_rescue
+Source0: https://rubygems.org/gems/%{gem_name}-%{version}.gem
+
+# start generated dependencies
+Requires: foreman >= %{foreman_min_version}
+Requires: %{?scl_prefix_ruby}ruby(release)
+Requires: %{?scl_prefix_ruby}ruby
+Requires: %{?scl_prefix_ruby}ruby(rubygems)
+BuildRequires: foreman-plugin >= %{foreman_min_version}
+BuildRequires: %{?scl_prefix_ruby}ruby(release)
+BuildRequires: %{?scl_prefix_ruby}ruby
+BuildRequires: %{?scl_prefix_ruby}rubygems-devel
+BuildArch: noarch
+Provides: %{?scl_prefix}rubygem(%{gem_name}) = %{version}
+Provides: foreman-plugin-%{plugin_name}
+# end generated dependencies
+
+%description
+Foreman Plugin to provide the ability to boot a host into a rescue system.
+
+
+%package doc
+Summary: Documentation for %{pkg_name}
+Group: Documentation
+Requires: %{?scl_prefix}%{pkg_name} = %{version}-%{release}
+BuildArch: noarch
+
+%description doc
+Documentation for %{pkg_name}.
+
+%prep
+%{?scl:scl enable %{scl} - << \EOF}
+gem unpack %{SOURCE0}
+%{?scl:EOF}
+
+%setup -q -D -T -n  %{gem_name}-%{version}
+
+%{?scl:scl enable %{scl} - << \EOF}
+gem spec %{SOURCE0} -l --ruby > %{gem_name}.gemspec
+%{?scl:EOF}
+
+%build
+# Create the gem as gem install only works on a gem file
+%{?scl:scl enable %{scl} - << \EOF}
+gem build %{gem_name}.gemspec
+%{?scl:EOF}
+
+# %%gem_install compiles any C extensions and installs the gem into ./%%gem_dir
+# by default, so that we can move it into the buildroot in %%install
+%{?scl:scl enable %{scl} - << \EOF}
+%gem_install
+%{?scl:EOF}
+
+%install
+mkdir -p %{buildroot}%{gem_dir}
+cp -pa .%{gem_dir}/* \
+        %{buildroot}%{gem_dir}/
+
+%foreman_bundlerd_file
+
+%files
+%dir %{gem_instdir}
+%license %{gem_instdir}/LICENSE
+%{gem_instdir}/app
+%{gem_instdir}/config
+%{gem_instdir}/db
+%{gem_libdir}
+%{gem_instdir}/locale
+%exclude %{gem_cache}
+%{gem_spec}
+%{foreman_bundlerd_plugin}
+
+%files doc
+%doc %{gem_docdir}
+%doc %{gem_instdir}/README.md
+%{gem_instdir}/Rakefile
+%{gem_instdir}/test
+
+%posttrans
+%{foreman_db_migrate}
+%{foreman_restart}
+exit 0
+
+%changelog
+* Tue Jun 05 2018 Dirk Goetz <dirk.goetz@netways.de> 1.0.0-1
+- Add rubygem-foreman_rescue generated by gem2rpm using the foreman_plugin template
+
diff --git a/rel-eng/tito.props b/rel-eng/tito.props
index b060d86e9..f65888e73 100644
--- a/rel-eng/tito.props
+++ b/rel-eng/tito.props
@@ -321,6 +321,7 @@ whitelist = rubygem-angular-rails-templates
   rubygem-foreman_openscap
   rubygem-foreman_remote_execution
   rubygem-foreman_remote_execution_core
+  rubygem-foreman_rescue
   rubygem-foreman_salt
   rubygem-foreman_setup
   rubygem-foreman_snapshot_management